--------------------------------------------------------------------------------
--
--  PRIKLAD ZO SKUSKY
--  ~~~~~~~~~~~~~~~~~
--
-- Autor: Ladislav Vastag
-- Datum: 21. maj 2004
-- mail: lvastag@pobox.sk (spz@szm.sk)
-- ICQ: 272-349-578
--
-- Definujte datovy typ pre vytvorenie vseobecneho stromu. Potom
-- 
--    - definujte operaciu (==) pre porovnanie hodnot a struktury dvoch 
--      vseobecnych stromov
--    - definujte funkciu "min" pre najdenie minimalnej hodnoty vrchola
--      vseobecneho stromu pre typy Char, Integer, Double, [a] (pomocou 
--      abstraktneho typu!!!!!)
--
-- Dodefinovanie: Budeme definovat funkciu "mini", lebo funkcia "min" je uz
-- v Haskell-i definovana. Na skuske mozete kludne definovat funkciu "min".
-- Papier to znesie.  ;-)
--
--------------------------------------------------------------------------------

--
-- Teraz si definujeme niekolko stromov pre odskusanie nasho prikladu, aby sme 
-- nemuseli stale tukat cez prikazovy riadok. POZOR!! Toto na skuske NIE JE 
-- NUTNE!!!!!!!!
--

--
-- Prvy strom - typ Gtree Integer
--
exampleTree_1 =
       Bin 2 [ 
               Bin 5 [
                       Bin 10 [
                                Val 3,
                                Val 8
                              ]
                     ],
               Val 6,
               Val 7
             ]

--
-- Druhy strom - typ Gtree Integer
--
exampleTree_2 =
       Bin 45 [ 
                Bin 85 [ 
                         Bin 10 [
                                  Val 32,
                                  Val 8
                                ]
                       ],
                Bin 64 [
                         Val 15,
                         Val 28
                       ],
                Val 7
              ]

--
-- Treti strom - typ Gtree Char
--
exampleTree_3 =
       Bin 'a' [
                 Bin '0' [
                           Val '3',
                           Val 'C'
                         ]
               ]

--
-- Stvrty strom - typ Gtree Double
--
exampleTree_4 =
       Bin 1.0 [
                Val 3.5,
                Val 8.7
              ]

--
-- Piaty strom  - typ Gtree Integer
--
exampleTree_5 =
       Bin [1,2,3] [
                     Val [3,25],
                     Val [8,7]
                   ]

--
-- Siesty strom - typ Gtree [Char]
--
exampleTree_6 =
       Bin ['a','2','C'] [
                           Val ['F','f','G'],
                           Val ['8','7','d','Q']
                         ]


-- Dalsie typy stromov ako napr.  Gtree [Integer] alebo Gtree [Double] si 
-- mozete dodefinovat sami.

--------------------------------------------------------------------------------
--         NASLEDUJUCU CAST JE POTREBNE VYCAROVAT NA PAPIER NA SKUSKE
--------------------------------------------------------------------------------
--
-- Definicia abstraktneho typu
--
data Gtree a = Val a | Bin a [Gtree a] deriving (Show)


--
-- Definovanie operacie (==) pre vseobecny strom
--
instance (Eq a) => Eq (Gtree a ) where
    (==) (Val x) (Val y) = x == y
    (==) (Bin x y) (Val z) = False
    (==) (Val z) (Bin x y) = False
    (==) (Bin x (y:ys)) (Bin u (v:vs)) = (x == u) && (y == v) && (ys == vs)


class (Ord a) => GTREE a where
    mini :: Gtree a -> a
    mini (Val x) = x
    mini (Bin x (y:ys)) = minimal x y ys
         where minimal x (Val y) [] | x <= y = x
                                    | otherwise = y

               minimal x (Val y) (z:zs) | x <= y = minimal x z zs
                                        | otherwise = minimal y z zs

               minimal x (Bin y (z:zs)) [] | x <= y = minimal y z zs
                                           | otherwise = minimal y z zs

               minimal x (Bin y (z:zs)) (v:vs) | x <= y = minimal (minimal x z zs) v vs
                                               | otherwise = minimal (minimal y z zs) v vs


instance GTREE Integer
instance GTREE Char
instance GTREE Double
instance (GTREE a) => GTREE [a]
--------------------------------------------------------------------------------
--                         THAT'S ALL FOLKS
--------------------------------------------------------------------------------
